-- WHEREIS.EX   Find any file on drive
-- builds directory file using dir /S (S scans sub-directories)
--------------------------------------------------------------------------------
include get.e
include file.e
include strtok.e
include wildcard.e
include graphics.e

with trace
allow_break(1)

sequence CommandLine,DosCommand,Rebuild

integer  len,pos,RecNo

object   fn1,fn2,DataRecord,UserFileName,FoundFileName,AllDirs,Output,result

atom     NumParameters,a,b,c

constant SCREEN = 1,true = 1

--------------------------------------------------------------------------------

clear_screen()
CommandLine = command_line()   -- ignore elements 1-2, user input is at 3
NumParameters = length(CommandLine) - 2

while true do
   if NumParameters = 0   then
      position(10,15)
      puts(SCREEN,"Enter file name to search for: ") UserFileName = gets(0)
      if length(UserFileName) = 0 then
         abort(1)
      else
         UserFileName = upper(UserFileName[1..length(UserFileName) -1])
      end if
   else
      UserFileName = CommandLine[3]     -- not 1-- see refman
   end if
   if length(UserFileName) > 0   then
      exit
   end if
end while

while true do
   position(12,15)
   puts(SCREEN,"Rebuild Directory Structure file (Y/N): ")
   position(13,29)
   puts(SCREEN,"(Default is N)")

   Rebuild = gets(0)
   Rebuild = Rebuild[1..length(Rebuild) - 1]
   Rebuild = upper(Rebuild)

   if length(Rebuild) > 0  then
      if equal(Rebuild,"Y") or equal(Rebuild,"N") then
         exit
      end if
   else
      Rebuild = "N"
      exit
   end if
end while

a = time()
if chdir("c:\\")  then
   if equal(Rebuild, "Y")   then
      position (16,30)
      puts(SCREEN,"Rebuilding ... please wait ...")
      system("dir /S /B /A > \\ALLDIRS.TXT",0)
   end if
else
   puts(1,"Error changing to root directory.")  abort(1)
end if

while true do
   fn1 = open("ALLDIRS.TXT","rb")
   if  equal(fn1,-1)  then        -- file isn't there... rebuild it.
       position(15,30)
       puts(SCREEN,"Directory Structure file is missing ...")
       position (16,30)
       puts(SCREEN,"Rebuilding ... please wait ...")
       system("dir /S /B /A > \\ALLDIRS.TXT",0)
       position(15,30)
       puts(SCREEN,"                                       ")
       position (16,30)
       puts(SCREEN,"                              ")
    else
       exit
   end if
end while


AllDirs = fn1

fn2 = open("WHEREIS.OUT","wb")
if  equal(fn2,-1)  then
    puts(1,"WHEREIS.OUT not opened. Aborting ...")  abort(1)
end if
Output = fn2
--trace(1)

cursor(NO_CURSOR)

RecNo = 0
while true do
      DataRecord = gets(AllDirs)
      if atom(DataRecord)  then
         exit
      end if

      if sequence(DataRecord) then
         DataRecord = upper(DataRecord[1..length(DataRecord) -2]) -- lose \r\n
         len = length(DataRecord)

         RecNo += 1
         position(16,20)
         puts(SCREEN,"Searching for file "&UserFileName&"  ...")
         position(18,20)
         printf(SCREEN,"Examining File No %6.0f \n",RecNo)

         for i = len to 1 by -1 do
             pos = i
             if DataRecord[pos] = '\\'  then     -- found last '\\'
                FoundFileName = DataRecord[pos +1..length(DataRecord)]
                exit
             end if
         end for

         result = wildcard_file(UserFileName, FoundFileName)
         if equal(result, 1) then
            puts(Output,DataRecord&"\n")
         end if
      end if
end while

close(AllDirs)
close(Output)

b = time()

position(20,30)
cursor(UNDERLINE_CURSOR)

DosCommand = "Edit WHEREIS.OUT"
system(DosCommand,0)
clear_screen()
position(22,30)
puts(SCREEN,"Output is in \\WHEREIS.OUT")

c = b - a
position(24,30)
printf(1,"Elapsed time = %8.2f seconds \n", c)
